// This file is part of the SV-Benchmarks collection of verification tasks:
// https://gitlab.com/sosy-lab/benchmarking/sv-benchmarks
//
// SPDX-FileCopyrightText: 2020 Aman Goel
// SPDX-FileCopyrightText: 2022 The SV-Benchmarks Community
//
// SPDX-License-Identifier: GPL-3.0-or-later

// This C program is converted from Btor2 by Btor2C version sha1:a0fa249
//   with arguments: { architecture=64, lazy_modulo=false, use_memmove=false, unroll_inner_loops=false, shortest_type=true, diff_type=true, decimal_constant=true, zero_init=false, sra_extend_sign=true }
// Comments from the original Btor2 file:
// ; source: https://github.com/aman-goel/avr/tree/92362931700b66684418a991d018c9fbdbebc06f/tests
// ; BTOR description generated by Yosys 0.9+431 (git sha1 4a3b5437, clang 4.0.1-6 -fPIC -Os) for module main.
extern unsigned char __VERIFIER_nondet_uchar();
extern unsigned short __VERIFIER_nondet_ushort();
extern unsigned int __VERIFIER_nondet_uint();
extern unsigned long __VERIFIER_nondet_ulong();
extern void abort(void);
extern void __assert_fail(const char *, const char *, unsigned int, const char *);
void reach_error() { __assert_fail("0", "vcegar_QF_BV_itc99_b13_p05.c", 0, "reach_error"); }
void __VERIFIER_assert(int cond) { if (!(cond)) { ERROR: { reach_error(); abort(); } } }
void assume_abort_if_not(int cond) { if (!cond) { abort(); } }
int main() {
  // Defining sorts ...
  typedef unsigned char SORT_1;  // BV with 1 bits
  const SORT_1 mask_SORT_1 = (SORT_1)-1 >> (sizeof(SORT_1) * 8 - 1);
  const SORT_1 msb_SORT_1 = (SORT_1)1 << (1 - 1);
  typedef unsigned char SORT_3;  // BV with 8 bits
  const SORT_3 mask_SORT_3 = (SORT_3)-1 >> (sizeof(SORT_3) * 8 - 8);
  const SORT_3 msb_SORT_3 = (SORT_3)1 << (8 - 1);
  typedef unsigned char SORT_7;  // BV with 4 bits
  const SORT_7 mask_SORT_7 = (SORT_7)-1 >> (sizeof(SORT_7) * 8 - 4);
  const SORT_7 msb_SORT_7 = (SORT_7)1 << (4 - 1);
  typedef unsigned short SORT_62;  // BV with 10 bits
  const SORT_62 mask_SORT_62 = (SORT_62)-1 >> (sizeof(SORT_62) * 8 - 10);
  const SORT_62 msb_SORT_62 = (SORT_62)1 << (10 - 1);
  // Initializing constants ...
  const SORT_7 var_8 = 0;
  const SORT_1 var_16 = 1;
  const SORT_1 var_20 = 0;
  // Collecting input declarations ...
  SORT_1 input_2;
  SORT_3 input_4;
  SORT_1 input_5;
  SORT_1 input_6;
  SORT_1 input_23;
  SORT_1 input_25;
  SORT_1 input_27;
  SORT_1 input_29;
  SORT_1 input_31;
  SORT_1 input_33;
  SORT_1 input_35;
  SORT_1 input_37;
  SORT_1 input_39;
  SORT_1 input_41;
  SORT_1 input_43;
  SORT_3 input_45;
  SORT_1 input_48;
  SORT_1 input_50;
  SORT_1 input_52;
  SORT_1 input_54;
  SORT_1 input_56;
  SORT_1 input_58;
  SORT_1 input_60;
  SORT_62 input_63;
  SORT_1 input_65;
  // Collecting state declarations ...
  SORT_7 state_9 = __VERIFIER_nondet_uchar() & mask_SORT_7;
  SORT_7 state_11 = __VERIFIER_nondet_uchar() & mask_SORT_7;
  SORT_1 state_21 = __VERIFIER_nondet_uchar() & mask_SORT_1;
  // Initializing states ...
  SORT_7 init_10_arg_1 = var_8;
  state_9 = init_10_arg_1;
  SORT_7 init_12_arg_1 = var_8;
  state_11 = init_12_arg_1;
  SORT_1 init_22_arg_1 = var_20;
  state_21 = init_22_arg_1;
  for (;;) {
    // Getting external input values ...
    input_2 = __VERIFIER_nondet_uchar();
    input_2 = input_2 & mask_SORT_1;
    input_4 = __VERIFIER_nondet_uchar();
    input_4 = input_4 & mask_SORT_3;
    input_5 = __VERIFIER_nondet_uchar();
    input_5 = input_5 & mask_SORT_1;
    input_6 = __VERIFIER_nondet_uchar();
    input_6 = input_6 & mask_SORT_1;
    input_23 = __VERIFIER_nondet_uchar();
    input_23 = input_23 & mask_SORT_1;
    input_25 = __VERIFIER_nondet_uchar();
    input_25 = input_25 & mask_SORT_1;
    input_27 = __VERIFIER_nondet_uchar();
    input_27 = input_27 & mask_SORT_1;
    input_29 = __VERIFIER_nondet_uchar();
    input_29 = input_29 & mask_SORT_1;
    input_31 = __VERIFIER_nondet_uchar();
    input_31 = input_31 & mask_SORT_1;
    input_33 = __VERIFIER_nondet_uchar();
    input_33 = input_33 & mask_SORT_1;
    input_35 = __VERIFIER_nondet_uchar();
    input_35 = input_35 & mask_SORT_1;
    input_37 = __VERIFIER_nondet_uchar();
    input_37 = input_37 & mask_SORT_1;
    input_39 = __VERIFIER_nondet_uchar();
    input_39 = input_39 & mask_SORT_1;
    input_41 = __VERIFIER_nondet_uchar();
    input_41 = input_41 & mask_SORT_1;
    input_43 = __VERIFIER_nondet_uchar();
    input_43 = input_43 & mask_SORT_1;
    input_45 = __VERIFIER_nondet_uchar();
    input_45 = input_45 & mask_SORT_3;
    input_48 = __VERIFIER_nondet_uchar();
    input_48 = input_48 & mask_SORT_1;
    input_50 = __VERIFIER_nondet_uchar();
    input_50 = input_50 & mask_SORT_1;
    input_52 = __VERIFIER_nondet_uchar();
    input_52 = input_52 & mask_SORT_1;
    input_54 = __VERIFIER_nondet_uchar();
    input_54 = input_54 & mask_SORT_1;
    input_56 = __VERIFIER_nondet_uchar();
    input_56 = input_56 & mask_SORT_1;
    input_58 = __VERIFIER_nondet_uchar();
    input_58 = input_58 & mask_SORT_1;
    input_60 = __VERIFIER_nondet_uchar();
    input_60 = input_60 & mask_SORT_1;
    input_63 = __VERIFIER_nondet_ushort();
    input_63 = input_63 & mask_SORT_62;
    input_65 = __VERIFIER_nondet_uchar();
    input_65 = input_65 & mask_SORT_1;
    // Assuming invariants ...
    // Asserting properties ...
    SORT_7 var_13_arg_0 = state_9;
    SORT_7 var_13_arg_1 = state_11;
    SORT_1 var_13 = var_13_arg_0 == var_13_arg_1;
    SORT_1 var_17_arg_0 = var_13;
    SORT_1 var_17 = ~var_17_arg_0;
    var_17 = var_17 & mask_SORT_1;
    SORT_1 var_18_arg_0 = var_16;
    SORT_1 var_18_arg_1 = var_17;
    SORT_1 var_18 = var_18_arg_0 & var_18_arg_1;
    var_18 = var_18 & mask_SORT_1;
    SORT_1 bad_19_arg_0 = var_18;
    __VERIFIER_assert(!(bad_19_arg_0));
    // Computing next states ...
    SORT_1 var_67_arg_0 = state_21;
    SORT_7 var_67_arg_1 = state_9;
    SORT_7 var_67_arg_2 = state_9;
    SORT_7 var_67 = var_67_arg_0 ? var_67_arg_1 : var_67_arg_2;
    SORT_7 next_68_arg_1 = var_67;
    SORT_1 var_69_arg_0 = state_21;
    SORT_7 var_69_arg_1 = state_11;
    SORT_7 var_69_arg_2 = state_11;
    SORT_7 var_69 = var_69_arg_0 ? var_69_arg_1 : var_69_arg_2;
    SORT_7 next_70_arg_1 = var_69;
    SORT_1 var_71_arg_0 = state_21;
    SORT_1 var_71_arg_1 = var_20;
    SORT_1 var_71_arg_2 = var_16;
    SORT_1 var_71 = var_71_arg_0 ? var_71_arg_1 : var_71_arg_2;
    SORT_1 next_72_arg_1 = var_71;
    // Assigning next states ...
    state_9 = next_68_arg_1;
    state_11 = next_70_arg_1;
    state_21 = next_72_arg_1;
  }
  return 0;
}
